; ####################################################
;       William F. Cravener 12/07/2003
; ####################################################
    
        .486
        .model flat,stdcall
        option casemap:none
    
; ####################################################
    
        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\gdi32.inc

        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib
        includelib \masm32\lib\gdi32.lib
    
        include mci.inc
        includelib mci.lib
        includelib mcicreate.lib

; ####################################################

        MCIWNDF_NOMENU equ 0008h

; ####################################################

        WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY PROTO   :DWORD,:DWORD

; ####################################################

.data
        hInstance      dd 0
        hWnd           dd 0
        hBmp           dd 0
        mcihWnd        dd 0
        Wwd            dd 0
        Wht            dd 0
        Wtx            dd 0
        Wty            dd 0
        filename       db "Yamahog.mp3",0
        szClassName    db "My Yamahog",0

.data?
        Bmap BITMAP <>

; ####################################################
    
.code

start:

      invoke GetModuleHandle,0
      mov hInstance,eax
      invoke LoadBitmap,hInstance,1002
      mov hBmp,eax
      invoke WinMain,hInstance,0,0,0
      invoke ExitProcess,0
  
; ###############################################################

WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG

      mov wc.cbSize,sizeof WNDCLASSEX
      mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,offset WndProc
      mov wc.cbClsExtra,0
      mov wc.cbWndExtra,0
      mov eax,hInst
      mov wc.hInstance,eax
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,0
      mov wc.lpszClassName,offset szClassName
      invoke LoadIcon,hInst,1001
      mov wc.hIcon,eax
      invoke LoadCursor,0,IDC_ARROW
      mov wc.hCursor,eax
      mov wc.hIconSm,0

      invoke RegisterClassEx,ADDR wc

      mov Wwd, 510
      mov Wht, 330

      invoke GetSystemMetrics,SM_CXSCREEN
      invoke TopXY,Wwd,eax
      mov Wtx,eax
      invoke GetSystemMetrics,SM_CYSCREEN
      invoke TopXY,Wht,eax
      mov Wty,eax

      invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                            ADDR szClassName,
                            ADDR szClassName,
                            WS_OVERLAPPED or WS_SYSMENU,
                            Wtx,Wty,Wwd,Wht,
                            0,0,
                            hInst,0
      mov hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

    StartLoop:
      invoke GetMessage,ADDR msg,0,0,0
      cmp eax,0
      je ExitLoop
      invoke TranslateMessage,ADDR msg
      invoke DispatchMessage,ADDR msg
      jmp StartLoop
    ExitLoop:

    ret

WinMain endp

; ##############################################################

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL hOld:DWORD
    LOCAL memDC:DWORD
    LOCAL hDC:DWORD
    LOCAL Ps:PAINTSTRUCT

    .if uMsg == WM_COMMAND

    .elseif uMsg == WM_CREATE
        invoke MCIWndCreate,hWin,hInstance,MCIWNDF_NOMENU,ADDR filename
        mov mcihWnd,eax
        ;========================================================================
        pop eax     ;For some reason 4 things are pushed onto stack unnecessarily
        pop eax     ;so they have to be popped off the stack to prevent crashing
        pop eax     ;Thanks to Ron Thomas for spotting that one!
        pop eax
        ;========================================================================
        invoke MCIWndPlay,mcihWnd

    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
        mov hDC,eax
        invoke CreateCompatibleDC,hDC
        mov memDC,eax
        invoke SelectObject,memDC,hBmp
        mov hOld,eax
        invoke GetObject,hBmp,SIZEOF Bmap,ADDR Bmap
        invoke BitBlt,hDC,0,0,Bmap.bmWidth,Bmap.bmHeight,memDC,0,0,SRCCOPY
        invoke SelectObject,hDC,hOld
        invoke DeleteDC,memDC
        invoke EndPaint,hWin,ADDR Ps
        xor eax,eax
        ret 

    .elseif uMsg == WM_DESTROY
        invoke MCIWndClose,mcihWnd
        invoke MCIWndDestroy,mcihWnd
        invoke PostQuitMessage,0
        xor eax,eax
        ret 

    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret

WndProc endp
    
; ##############################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim,1
    shr wDim,1
    mov eax,wDim
    sub sDim,eax
    mov eax,sDim
    ret 

TopXY endp

; ##############################################################

end start
